<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDispatcherResult_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDispatcherResult_V2 extends AbstractStructArrayBase
{
    /**
     * The DispatcherResult_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DispatcherResult_V2[]
     */
    public $DispatcherResult_V2;
    /**
     * Constructor method for ArrayOfDispatcherResult_V2
     * @uses ArrayOfDispatcherResult_V2::setDispatcherResult_V2()
     * @param \StructType\DispatcherResult_V2[] $dispatcherResult_V2
     */
    public function __construct(array $dispatcherResult_V2 = array())
    {
        $this
            ->setDispatcherResult_V2($dispatcherResult_V2);
    }
    /**
     * Get DispatcherResult_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DispatcherResult_V2[]|null
     */
    public function getDispatcherResult_V2()
    {
        return isset($this->DispatcherResult_V2) ? $this->DispatcherResult_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDispatcherResult_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDispatcherResult_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDispatcherResult_V2ForArrayConstraintsFromSetDispatcherResult_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDispatcherResult_V2DispatcherResult_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfDispatcherResult_V2DispatcherResult_V2Item instanceof \StructType\DispatcherResult_V2) {
                $invalidValues[] = is_object($arrayOfDispatcherResult_V2DispatcherResult_V2Item) ? get_class($arrayOfDispatcherResult_V2DispatcherResult_V2Item) : sprintf('%s(%s)', gettype($arrayOfDispatcherResult_V2DispatcherResult_V2Item), var_export($arrayOfDispatcherResult_V2DispatcherResult_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DispatcherResult_V2 property can only contain items of type \StructType\DispatcherResult_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DispatcherResult_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult_V2[] $dispatcherResult_V2
     * @return \ArrayType\ArrayOfDispatcherResult_V2
     */
    public function setDispatcherResult_V2(array $dispatcherResult_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($dispatcherResult_V2ArrayErrorMessage = self::validateDispatcherResult_V2ForArrayConstraintsFromSetDispatcherResult_V2($dispatcherResult_V2))) {
            throw new \InvalidArgumentException($dispatcherResult_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($dispatcherResult_V2) || (is_array($dispatcherResult_V2) && empty($dispatcherResult_V2))) {
            unset($this->DispatcherResult_V2);
        } else {
            $this->DispatcherResult_V2 = $dispatcherResult_V2;
        }
        return $this;
    }
    /**
     * Add item to DispatcherResult_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult_V2 $item
     * @return \ArrayType\ArrayOfDispatcherResult_V2
     */
    public function addToDispatcherResult_V2(\StructType\DispatcherResult_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DispatcherResult_V2) {
            throw new \InvalidArgumentException(sprintf('The DispatcherResult_V2 property can only contain items of type \StructType\DispatcherResult_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DispatcherResult_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DispatcherResult_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DispatcherResult_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DispatcherResult_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DispatcherResult_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DispatcherResult_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DispatcherResult_V2
     */
    public function getAttributeName()
    {
        return 'DispatcherResult_V2';
    }
}
